vs.1.1

// Compute the vertex position in projection space
m4x4 oPos, v0, c0

// Compute a normalized camera to vertex vector
sub r0, v0, c7
dp3 r0.w, r0, r0
rsq r0.w, r0.w
mul r0, r0, r0.w
mov r1, r0

// Compute the dot-product between the plane of the magnifier and the camera to vertex 
// vector and take it's reciprocal
dp3 r0.w, -r0, c10
rcp r0.w, r0.w

// Compute a linear combination of the normal, the camera to vertex vector and the 
// magnifier plane normal vector
mul r0.w, r0.w, c9.y
mad r0, r0.w, c10, r0

mad r0, v3, c9.x, r0

// Get the computed vector from mesh space to world space and use it as texture 
// coordinate for the environment map
m3x3 oT0, r0, c4

mov oD0, c8

// Retrieve the normalized camera to vertex vector
mov r0, r1

// Compute the normalized light to vertex vector
sub r1, v0, c11
dp3 r1.w, r1, r1
rsq r1.w, r1.w
mul r1.xyz, r1.xyz, r1.w

// Compute the reflection vector using the formula r=v-n*2*<v,n>
dp3 r0.w, r0, v3
mul r0.w, r0.w, c12.x
mad r0, v3, r0.w, r0

// Compute the dot product between the reflection vector and the light differenc vector
dp3 r0.w, r1, -r0
// Make sure that the value isn't smaller than zero
max r0.w, c12.y, r0.w
// Take the specular factor (the dot product) to the power of 16 and pass the result as 
// specular color
mul r0.w, r0.w, r0.w
mul r0.w, r0.w, r0.w
mul r0.w, r0.w, r0.w
mul oD1.rgb, r0.w, r0.w
