// This shader effect creates a layer with dynamically changing normal mapped 
// clouds. To reach authentic results it computes the cloud intensity from two 
// changing values, the absolute humidity and the maximum humidity which lead to 
// the relative humidity together. If the relative humidity exceeds a particular 
// value a cloud appears. This vertex shader mostly computes time dependent 
// texture coordinates for the pixel shader.
vs.1.1

// Compute the vertex position in projection space
m4x4 oPos, v0, c0

// Compute the current time value
mov r0.xyzw, c4.x
mul r0.xyzw, r0.xyzw, c5.x
// Apply the texture scaling factor to the texture coordinate
mul r1, c9, v7
// Compute the time dependent absolute humidity texture coordinate
mad oT0, r0, c6, r1
// Compute the time dependent absolute humidity perturbation texture coordinate
mad oT1, r0, c7, r1
// Compute the time dependent maximum humidity texture coordinate
mad oT2, r0, c8, r1

// Compute the moon to vertex difference vector
add oT3.xyzw, -v0.xzyw, c10.xyz
